part of 'app_test.dart';

Future<void> _logged([bool forceLinkedLocal = true]) async {
  await initializeApp();
  await StorageHelper() //
      .set(SecureStorageKey.isLogged.value, 'true');
  await StorageHelper() //
      .set(SecureStorageKey.haveLocal.value, 'true');
  await StorageHelper() //
      .set(ProfileStorageKey.devUUID.key, 'b5c3818753e76d85');
  await StorageHelper() //
      .set(ProfileStorageKey.userUUID.key, '649c45d7514a28.85876308');

  await StorageHelper() //
      .set(SecureStorageKey.email.value, 'email_app@exemplo.com');
  await StorageHelper() //
      .set(SecureStorageKey.password.value, '123456');
  await StorageHelper() //
      .set(LocalsStorageKey.isNewVersion.key, true);
  if (forceLinkedLocal == true) {
    await StorageHelper() //
        .set(ProfileStorageKey.clientUUID.key, '7');
    await PhpGroup //
        .resopndeVinculo
        .call(tarefa: 'A');
    await LicenseRepositoryImpl() //
        .resetLicense();
  }
}

Future<void> _unlogged() async {
  await initializeApp();
  await StorageHelper() //
      .set(SecureStorageKey.isLogged.value, 'false');
  await StorageHelper() //
      .set(SecureStorageKey.haveLocal.value, 'false');
  await StorageHelper() //
      .set(ProfileStorageKey.devUUID.key, '');
  await StorageHelper() //
      .set(ProfileStorageKey.userUUID.key, '');
  await StorageHelper() //
      .set(ProfileStorageKey.clientUUID.key, '');
  await StorageHelper() //
      .set(SecureStorageKey.email.value, '');
  await StorageHelper() //
      .set(SecureStorageKey.password.value, '');
  await StorageHelper() //
      .set(LocalsStorageKey.isNewVersion.key, true);
}

Future<void> _navigateToSignIn(PatrolTester $) async {
  final signInButton = $(#toggleSignInPage).waitUntilVisible();
  await signInButton.tap();
}

Future<void> _navigateToSignUp(PatrolTester $) async {
  final signUpButton = $(#toggleSignUpPage).waitUntilVisible();
  await signUpButton.tap();
}

Future<void> _navigateBackUsingSystemGesture() async =>
    IntegrationTestWidgetsFlutterBinding.instance.keyboard
        .isLogicalKeyPressed(LogicalKeyboardKey.escape);
